Summary: Midnight Commander visual shell
Name: mc
Version: 4.0
Release: 1
Copyright: GPL
Group: Shells
Source0: ftp://peyote-asesino.nuclecu.unam.mx/linux/local/devel/mc-4.0.tar.gz
URL: http://www.linux.org/mc/
BuildRoot: /tmp/mc-root
Packager: Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl> + Michele Marziani <marziani@fe.infn.it>

%description
Midnight Commander is a visual shell much like a file manager, only
with way more features.  It is text mode, but also includes mouse
support if you are running GPM.  It's coolest feature is the ability
to ftp, view tar, zip files and poke into RPMs for specific files.  :-)

%package -n tkmc
Summary: Midnight Commander visual shell (tk version)
Requires: mc
Group: X11/Shells
%description -n tkmc
Midnight Commander is a visual shell much like a file manager, only with
way more features.  It is tk X window wersion. It's coolest feature is the
ability to ftp, view tar, zip files and poke into RPMs for specific files.
The tk version of Midnight Commander is not yet finished though. :-(
 
%package -n mcserv
Summary: Midnight Commander file server
Group: X11/Shells
%description -n mcserv
mcserv is the server program for the Midnight Commander networking file
system. It provides access to the host file system to clients running the
Midnight file system (currently, only the Midnight Commander file manager).

%prep
%setup

rm -Rf $RPM_BUILD_ROOT

%build
CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="-s" ./configure --prefix=/usr --with-tk

make
cd tk
make tkmc
cd ..

%install
install -d $RPM_BUILD_ROOT/etc/rc.d/{init.d,rc0.d,rc1.d,rc2.d,rc3.d,rc4.d,rc5.d,rc6.d}
install -d $RPM_BUILD_ROOT/etc/{pam.d,profile.d}

make prefix=$RPM_BUILD_ROOT/usr install
cd icons
make prefix=$RPM_BUILD_ROOT/usr install_icons
rm -f $RPM_BUILD_ROOT/usr/lib/mc/FAQ

strip $RPM_BUILD_ROOT/usr/bin/mc $RPM_BUILD_ROOT/usr/bin/mcserv

cd ..
install -c -o root -g root -m 744 lib/mcserv.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d
ln -sf ../init.d/mcserv.init $RPM_BUILD_ROOT/etc/rc.d/rc0.d/K30mcserv
ln -sf ../init.d/mcserv.init $RPM_BUILD_ROOT/etc/rc.d/rc1.d/K30mcserv
ln -sf ../init.d/mcserv.init $RPM_BUILD_ROOT/etc/rc.d/rc2.d/S86mcserv
ln -sf ../init.d/mcserv.init $RPM_BUILD_ROOT/etc/rc.d/rc3.d/S86mcserv
ln -sf ../init.d/mcserv.init $RPM_BUILD_ROOT/etc/rc.d/rc5.d/S86mcserv
ln -sf ../init.d/mcserv.init $RPM_BUILD_ROOT/etc/rc.d/rc6.d/K30mcserv


install -o root -g root -m 644 lib/mcserv.pamd \
	$RPM_BUILD_ROOT/etc/pam.d/mcserv
install -o root -g root -m 755 lib/mc.sh \
	$RPM_BUILD_ROOT/etc/profile.d
install -o root -g root -m 755 lib/mc.csh \
	$RPM_BUILD_ROOT/etc/profile.d

install -s -o root -g root -m 755 tk/tkmc $RPM_BUILD_ROOT/usr/bin

%files
%doc FAQ COPYING NEWS README
/usr/bin/mc
/usr/bin/mcedit
/usr/bin/mcmfmt
/usr/lib/mc/mc.ext
/usr/lib/mc/mc.hint
/usr/lib/mc/mc.hlp
/usr/lib/mc/mc.lib
/usr/lib/mc/mc.menu
/usr/lib/mc/bin/cons.saver
/usr/lib/mc/extfs/*
/usr/man/man1/mc.1
/usr/man/man1/mcedit.1
%config /etc/profile.d/mc.sh
%config /etc/profile.d/mc.csh
%dir /usr/lib/mc/
%dir /usr/lib/mc/bin
%dir /usr/lib/mc/extfs

%files -n mcserv
%config /etc/pam.d/mcserv
%config /etc/rc.d/init.d/mcserv.init
%config /etc/rc.d/rc0.d/K30mcserv
%config /etc/rc.d/rc1.d/K30mcserv
%config /etc/rc.d/rc2.d/S86mcserv
%config /etc/rc.d/rc3.d/S86mcserv
%config /etc/rc.d/rc5.d/S86mcserv
%config /etc/rc.d/rc6.d/K30mcserv
/usr/man/man8/mcserv.8
/usr/bin/mcserv

%files -n tkmc
/usr/bin/tkmc
/usr/lib/mc/gd.tcl
/usr/lib/mc/gui.tcl
/usr/lib/mc/mc.tcl


%changelog
* Thu May 22 1997 Michele Marziani <marziani@fe.infn.it>
- added support for mc alias in /etc/profile.d/mc.csh (for csh and tcsh)
- lowered number of SysV init scripts in /etc/rc.d/rc[0,1,6].d
  (mcserv needs to be killed before inet)
- removed all references to $RPM_SOURCE_DIR
- restored $RPM_OPT_FLAGS when compiling
- minor cleanup of spec file: redundant directives and comments removed
* Sun May 18 1997 Michele Marziani <marziani@fe.infn.it>
- removed all references to non-existent mc.rpmfs
- added mcedit.1 to the %files section
- reverted to un-gzipped man pages (RedHat style)
- removed double install line for mcserv.pamd
* Tue May 13 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>
- added new rpmfs script,
- removed mcfn_install from mc (adding mc() to bash enviroment is in
  /etc/profile.d/mc.sh),
- /etc/profile.d/mc.sh changed to %config,
- removed /usr/lib/mc/bin/create_vcs,
- removed /usr/lib/mc/term.
* Wed May 9 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>
- changed source url,
- fixed link mcedit to mc,
* Tue May 7 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>
- new version 3.5.27,
- %dir /usr/lib/mc/icons and icons removed from tkmc,
- added commented xmc part.
* Tue Apr 22 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>
- FIX spec:
   - added URL field,
   - in mc added missing /usr/lib/mc/mc.ext, /usr/lib/mc/mc.hint,
     /usr/lib/mc/mc.hlp, /usr/lib/mc/mc.lib, /usr/lib/mc/mc.menu.
* Fri Apr 18 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>
- added making packages: tkmc, mcserv (xmc not work yet),
- gziped man pages,
- added /etc/pamd.d/mcserv PAM config file.
- added instaling icons,
- added /etc/profile.d/mc.sh,
- in %doc added NEWS README,
- removed /usr/lib/mc/FAQ,
- added mcserv.init script for mcserv (start/stop on level 86).
